﻿var $iconElement = null;
var manager_user_select2_data_option = { id: "MANAGER", text: "Manažer" };
var solver_user_select2_data_option = { id: "SOLVER", text: "Řešitel" };

$(document).ready(function () {
    $("#Emails").select2({
        minimumInputLength: 0,
        allowClear: true,
        multiple: true,
        tags: true,
        width: '100%',
        dropdownAutoWidth: true,
        tokenSeparators: [',', ';', ' '],
        createTag: function (tag) { //pro vlastni tagy
            if (isValidEmailAddress(tag.term)) { //kontrola validni email adresy
                return {
                    id: tag.term,
                    text: tag.term
                };
            }
            else return null;
        },
        ajax: {
            url: RQ_URL + '/Account/UsersWithEmailForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;
                if (data.PageNum == 1) {
                    data.Results.unshift(manager_user_select2_data_option);
                    data.Results.unshift(solver_user_select2_data_option);
                }

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
    });

    $(".satisfaction-icons input[type='radio']").change(function () {
        if ($(this).is(":checked")) {
            var icons = $(this).closest(".satisfaction-icons").find(".satisfaction-icon");
            $("#SelectedIconsForNotifications").val(null).trigger("change");
            $("#SelectedIconsForNotifications").empty();
            $.each(icons, function (index, value) {
                var myId = $(value).find(".icon-my-id").val();
                var myText = $(value).find(".icon-text").val();
                if (!myText.trim()) {
                    myText = (index + 1);
                }
                $("#SelectedIconsForNotifications").append($("<option value='" + myId + "'></option>").text(myText));
            });
            $("#SelectedIconsRequeiredComment").val(null).trigger("change");
            $("#SelectedIconsRequeiredComment").empty();
            $.each(icons, function (index, value) {
                var myId = $(value).find(".icon-my-id").val();
                var myText = $(value).find(".icon-text").val();
                if (!myText.trim()) {
                    myText = (index + 1);
                }
                $("#SelectedIconsRequeiredComment").append($("<option value='" + myId + "'></option>").text(myText));
            });

            if ($(this).val() == 5) {
                $("#ShowCsat").prop("disabled", false);
            }
            else {
                $("#ShowCsat").prop("disabled", true);
            }
            if ($(this).val() == 10) {
                $("#ShowNps").prop("disabled", false);
            }
            else {
                $("#ShowNps").prop("disabled", true);
            }
        }
    });

    $(".satisfaction-icons input[type='radio']").trigger("change");

    $("#Emails").val(selectedEmails).trigger("change");

    $("#Services").val(defaultValueForServices).trigger("change");
    $("#SelectedIconsForNotifications").val(selectedIcons).trigger("change");
    $("#SelectedIconsRequeiredComment").val(selectedIconsForRequiredComment).trigger("change");

    //nastavení
    $(".searchable100Template").select2({
        width: '100%',
        templateSelection: function (service) {
            var name = $('<div/>').html($(service.element).data("name")).text();
            var element = $(service.element).parent();
            while (element.is("option") || element.is("optgroup")) {
                name = $(element).data("name") + "/" + name;
                var element = $(element).parent();
            }
            return name;
        },

    });

    $("body").on("click", ".satisfaction-icon", function () {
        $iconElement = $(this);
        $("#DialogText").val($iconElement.find("div").text().trim());
        $("#DialogTextResult").val($iconElement.find(".icon-text-result").val());
        $("#DialogNewIcon").find(".dialog-new-icon-icon").attr("src", $iconElement.find("img").attr("src"));
        $("#DialogNewIcon").dialog("open");
    });

    $("body").on("click", ".satisfaction-own-text", function () {
        tinymce.get("DialogTextAfterFilling").setContent($("#TextAfterFilling").val());
        $("#DialogOwnText").dialog("open");
    });

    $("body").on("change", "#ShowFieldForComment", function () {
        $("#CommentLabel").prop("disabled", !$(this).is(":checked"));
        $("#RequeiredCommentForSelectedSatisfaction").prop("disabled", !$(this).is(":checked"));
        $("#SelectedIconsRequeiredComment").prop("disabled", !$(this).is(":checked"));
    });

    $("#ShowFieldForComment").trigger("change");

    $("body").on("change", "#NotitificationOnlyFor", function () {
        $("#SelectedIconsForNotifications").prop("disabled", !$(this).is(":checked"));
    });

    $("body").on("change", "#RequeiredCommentForSelectedSatisfaction", function () {
        $("#SelectedIconsRequeiredComment").prop("disabled", !$(this).is(":checked"));
    });

    $("#RequeiredCommentForSelectedSatisfaction").trigger("change");

    $("#NotitificationOnlyFor").trigger("change");

    $("body").on("click", ".satisfaction-notification", function () {
        $("#DialogNotificationSubject").val($("#NotificationSubject").val());
        tinymce.get("DialogNotificationText").setContent($("#NotificationText").val());
        $("#DialogEmailNotification").dialog("open");
    });

    $("#DialogSetDefaultIcon").click(function () {
        $("#DialogIcon").val("");
        $("#FileValidError").hide();
        $iconElement.find(".icon-set-default").val(true);
        $("#DialogNewIcon").find(".dialog-new-icon-icon").attr("src", RQ_URL + "/Admin/Satisfactions/GetIcon?index=" + $iconElement.find(".icon-index").val() + "&type=" + $iconElement.find(".icon-type").val());
        $iconElement.find("img").attr("src", $("#DialogNewIcon").find(".dialog-new-icon-icon").attr("src"));
        $iconElement.find(".icon-was-changed").val(true);
    });

    $("#DialogSetUploadIcon").click(function () {
        $("#FileValidError").hide();
        var files = $("#DialogIcon").prop("files");
        if (files.length > 0) {
            //existuje aspoň jeden obrázek tak to není default
            $iconElement.find(".icon-set-default").val(false);
            if (window.FormData !== undefined) {
                var data = new FormData();
                for (var x = 0; x < files.length; x++) {
                    data.append("file" + x, files[x]);
                }

                $.ajax({
                    type: "POST",
                    url: RQ_URL + '/Admin/Satisfactions/UploadIcon',
                    contentType: false,
                    processData: false,
                    async: false,
                    data: data,
                    success: function (result) {
                        if (result.success) {
                            $iconElement.find(".icon-file-name").val(result.fileName);
                            $iconElement.find(".icon-was-changed").val(true);
                            $("#DialogNewIcon").find(".dialog-new-icon-icon").attr("src", RQ_URL + "/Admin/Satisfactions/GetFileIcon/" + result.fileName);
                            $iconElement.find("img").attr("src", $("#DialogNewIcon").find(".dialog-new-icon-icon").attr("src"));
                        }
                        else {

                        }
                    },
                    error: function (xhr, status, p3, p4) {
                        var err = "Error " + " " + status + " " + p3 + " " + p4;
                        if (xhr.responseText && xhr.responseText[0] == "{")
                            err = JSON.parse(xhr.responseText).Message;
                        console.log(err);
                    }
                });
            } else {
                alert("This browser doesn't support HTML5 file uploads!");
            }
        }
        else {
            $("#FileValidError").show();
        }
    });

    $("body").on("change", "#SendEmail", function () {
        if ($(this).is(":checked")) {
            if (!$("#ActionAfterFillUrl").is(":checked") && !$("#ActionAfterFillOwnText").is(":checked")) {
                $("#ActionAfterFillOwnText").prop("checked", true);
            }
            $(".satisfaction-url-setting").find("input").prop("disabled", false);
        }
        else {
            $(".satisfaction-url-setting").find("input").prop("disabled", true);
        }
    });

    $("#SendEmail").trigger("change");

    $("#DialogOwnText").dialog({
        autoOpen: false,
        resizable: true,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Ok,
            click: function () {
                $("#TextAfterFilling").val(tinymce.get("DialogTextAfterFilling").getContent());
                $("#DialogOwnText").dialog("close");
            }
        }, {
            text:Localization_Close,
            click:function () {
                $("#DialogOwnText").dialog("close");
            }
        }]
    });

    $("#DialogEmailNotification").dialog({
        autoOpen: false,
        resizable: true,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Ok,
            click: function () {
                $("#NotificationSubject").val($("#DialogNotificationSubject").val());
                $("#NotificationText").val(tinymce.get("DialogNotificationText").getContent());
                $("#DialogEmailNotification").dialog("close");
            }
        }, {
            text: Localization_Close,
            click: function () {
                $("#DialogEmailNotification").dialog("close");
            }
        }]
    });

    tinymce.init({
        selector: ".tinymce",
        cache_suffix: "?ver=" + ver,
        width: 650,
        autoresize_min_height: 250,
        theme: "silver",
        plugins: [
            "autoresize advlist autolink lists link image charmap print preview anchor",
            "searchreplace visualblocks code fullscreen",
            "insertdatetime media table paste textcolor"
        ],
        toolbar1: "bold italic | forecolor backcolor | link image | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent",
        entity_encoding: "raw",
        convert_fonts_to_spans: true,
        paste_data_images: true,
        language: language,
        branding: false,
        contextmenu: false,
        setup: function (editor) {
            editor.on('change', function (e) {
            });
        }
    });

    $("#DialogNewIcon").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Ok,
            click: function () {
                $iconElement.find("div").text($("#DialogText").val());
                $iconElement.find(".icon-text").val($("#DialogText").val());
                $iconElement.find(".icon-text-result").val($("#DialogTextResult").val());

                $("#DialogNewIcon").dialog("close");
            }
        }, {
            text: Localization_Close,
            click: function () {
                $("#DialogNewIcon").dialog("close");
            }
        }],
    });
});

function addText(constant) {
    tinyMCE.activeEditor.dom.add(tinyMCE.activeEditor.getBody(), 'p', {}, constant);
}