﻿/**
    URL adresy se definují na stránce která to používá

    Myšleno jako sdílené akce s požadavkem na více místech.
**/

var actionTotalNumber = 0;
var specialSendToValues = new Array();
specialSendToValues.push({ Text: "(zadavatel požadavku)", Value: "TICKET_SUBMITTER" });
specialSendToValues.push({ Text: "(řešitel požadavku)", Value: "TICKET_SOLVER" });
specialSendToValues.push({ Text: "(manažer požadavku)", Value: "TICKET_MANAGER" });

$(document).ready(function () {
    initActions();
});

function initActions() {
    $(".automatic-actions").on("change", ".all-checkbox", function () {
        $(this).closest(".action-for-automation-event").find(".everybodyCanSee").val($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $(this).closest(".action-for-automation-event").find(".only-user-select").hide();
        }
        else {
            $(this).closest(".action-for-automation-event").find(".only-user-select").show();
        }
    });
    $(".automatic-actions").on("change", ".js-requestSpecialHeader", function () {
        $(this).closest(".form-group").find(".js-requestSpecialHeaderValue").val($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $(this).closest(".form-group").find(".js-headerBox").show();
        }
        else {
            $(this).closest(".form-group").find(".js-headerBox").hide();
        }
    });
    $(".automatic-actions").on("change", ".js-requestAuthentication", function () {
        $(this).closest(".form-group").find(".js-requestAuthenticationValue").val($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $(this).closest(".form-group").find(".js-authenticationBox").show();
        }
        else {
            $(this).closest(".form-group").find(".js-authenticationBox").hide();
        }
    });
    $(".automatic-actions .all-checkbox").trigger("change");

    $(".automatic-actions").sortable({
        handle: ".handle",
        stop: function (event, ui) {
            setOrder();
        }
    });

    $(".automatic-actions").on("change", ".dropDownListSelectForm", function () {
        disableSelectedForms();
        $(this).closest(".setForm").find(".setFormVisual").html("<div class='loading-32'></div>");
        $(this).closest(".setForm").find(".setFormVisual").load(RQ_URL + "/Admin/AutomationEvents/CustomFormPartial/" + $(this).val() + "?index=" + $(this).closest(".action-for-automation-event").find(".array-id").val());
    });
}

function disableSelectedForms() {
    $(".dropDownListSelectForm option").removeAttr("disable");
    $(".dropDownListSelectForm").each(function () {
        var $dropDownListSelectForm = $(this);
        var selectedValue = $dropDownListSelectForm.val();
        $(".dropDownListSelectForm").each(function () {
            if (!$dropDownListSelectForm.is(this)) {
                $(this).find("option[value='" + selectedValue + "']").attr("disabled", "disabled");
            }
        });
    });
    $(".automatic-actions .dropDownListSelectForm").select2({ placeholder: Localization_SelectInSelect });
}

function setOrder() {
    $(".action-for-automation-event > .order").each(function (index) {
        $(this).val(index);
    });
}

function addNewAction() {
    $(newActionButton).hide();

    $.ajax({
        url: RQ_URL + getAction,
        type: "POST",
        data: JSON.stringify({
            areaType: $('#ddlAreaType').val(),
            index: actionTotalNumber
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            actionTotalNumber++;
            $(".automatic-actions").append(g);
            initAutomationEventAction();
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function createActionOptions(fields) {
    var currentGroupKey;
    var groupOpened = false;
    var options = "<option value='-1'>" + Localization_SelectInSelect + "</option>";

    for (var j = 0; j < fields.length; j++) {
        if (currentGroupKey != fields[j].GroupKey) {
            currentGroupKey = fields[j].GroupKey;

            if (groupOpened) {
                options += "</optgroup>";
            }

            options += '<optgroup label="' + fields[j].GroupName + '" value="' + fields[j].GroupKey + '">';
            groupOpened = true;
        }
        var htmlattributes = "";
        $(fields[j].HtmlAttributes).each(function () {
            htmlattributes += " " + this.Name + "='" + this.Value + "'";
        });

        options += "<option value='" + fields[j].Value + "'" + htmlattributes + ">" + fields[j].Text + "</option>";
    }
    if (groupOpened) {
        options += "</optgroup>";
    }
    return options;
}

function actionFieldChanged($rootElement) {
    $element = $rootElement.find("> .action-select");
    var actionId = $element.find("> .action-type").val();
    //vytáhnu si id abych mohl vytvořit stejný prefix jako rodič
    var idForJavascriptArray = $rootElement.find("> .array-id").val();
    $rootElement.find(".action-value").empty();
    var priorityId = $element.find("> .action-type option:selected").data('priorityid');
    var categoryId = $element.find("> .action-type option:selected").data('categoryid');

    $rootElement.find(".priority-id").val(priorityId);
    $rootElement.find(".category-id").val(categoryId);

    $.ajax({
        url: RQ_URL + getActionValue + "?automationEventAction=" + actionId + "&priorityId=" + priorityId + "&categoryId=" + categoryId + "&index=" + idForJavascriptArray + "&area=" + $("#ddlAreaType").val(),
        context: document.body,
        async: false
    }).done(function (data) {
        $rootElement.find(".action-value").append(data);
        if (actionId == 16 || actionId == 7 || actionId == 10 || actionId == 4 || actionId == 11) {
            $rootElement.find(".action-value").removeClass("inline");
        } else if (!$rootElement.find(".action-value").hasClass("inline")) {
            $rootElement.find(".action-value").addClass("inline");
        }
        setOrder();
        initAutomationEventAction();
    })
    .fail(function (error) {
        alert(error.responseText);
    });
}

function AreActionsValid() {
    var actions = $(".automatic-actions").children(".action-for-automation-event");
    var result = true;

    for (var i = 0; i < actions.length; i++) {
        if ($(actions[i]).find(".action-type").val() == "-1") {
            result = false;
        }

        if ($(actions[i]).find(".fieldType").val() == "textbox") {
            if ($(actions[i]).find(".textValue").val() == "" || $(actions[i]).find(".textValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "textarea") {
            if ($(actions[i]).find(".textareaValue").val() == "" || $(actions[i]).find(".textareaValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "addnote") {
            if ($(actions[i]).find(".textValue").val() == "" || $(actions[i]).find(".textValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "email") {
            if ($(actions[i]).find(".textValue").val() == "" || $(actions[i]).find(".textValue").val() == null || $(actions[i]).find(".userEmail").val() == null ||
                $(actions[i]).find(".subjectValue").val() == "" || $(actions[i]).find(".subjectValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "webhook") {
            if (($(actions[i]).find(".js-urlValue").val() == "" || $(actions[i]).find(".js-urlValue").val() == null) && ($(actions[i]).find(".js-requestPassword").val().length + $(actions[i]).find(".js-requestUserName").val().length + 1 > 255)) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "invitation") {
            if ($(actions[i]).find(".operator-group-value").val() == null && $(actions[i]).find(".internal-group-value").val() == null && $(actions[i]).find(".customer-group-value").val() == null && $(actions[i]).find(".dropdownlistusersValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "priority") {
            if ($(actions[i]).find(".priorityImpactValue").val() == null || $(actions[i]).find(".priorityUrgencyValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistmultiple") {
            if ($(actions[i]).find(".dropdownlistMultipleValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlist") {
            if ($(actions[i]).find(".dropdownlistValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistuser") {
            if ($(actions[i]).find(".dropdownlistuserValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistuseroperator") {
            if ($(actions[i]).find(".dropdownlistuseroperatorValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "nothing") {
            //není potřeba dělat nic
        }


        $(actions[i]).find(".valid-error").toggle(!result);
    }

    return result;
}

var closingColorPicker = false;

$.fn.initColorpicker = function () {
    $(this).colorpicker({
        colorSelectors: {
            'stickynote': '#ffffcc',
            'orange': '#f0ad4e',
            'green': '#5cb85c',
            'lightblue': '#5bc0de',
            'darkblue': '#337ab7',
            'lightred': '#d9534f',
            'darkred': '#b90600',
            'pink': '#ec2b8c',
            'purple': '#763f98',
            'default': '#7f7f7f',
            'chocolate': '#7B3F00',
        }
    })
        .on('changeColor', function (event) {
            var color = event.color;
            color.a = '0.9';
            $(this).closest(".ticket-sticky-note").css('background-color', color.toHex());
        })
        .on('hidePicker', function (event) {
            if (!closingColorPicker) { //hack to prevent calling this twice, maybe colorpicker bug

                closingColorPicker = true;
            }
        });
}

function resetActions() {
    $('.automatic-actions').empty();
    $('.btn-new-automation-action').show();
}

function initAutomationEventAction() {
    $(".automatic-actions .dropdownlistMultipleValue").select2({ placeholder: Localization_SelectInSelect });
    $(".automatic-actions .dropdownlistValue").select2({ placeholder: Localization_SelectInSelect, escapeMarkup: function (markup) { return markup; }, });
    $(".automatic-actions .dropDownListSelectForm").select2({ placeholder: Localization_SelectInSelect });
    $(".automatic-actions .action-type").select2({ width: 450, dropdownAutoWidth: true, placeholder: Localization_SelectInSelect });
    $(".automatic-actions .select2-for-actions").select2({ placeholder: Localization_SelectInSelect });
    $(".automatic-actions .userValue ").select2({
        minimumInputLength: 0,
        multiple: false,
        width: '100%',
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    $(".automatic-actions .dropdownlistuserValue").select2({
        minimumInputLength: 0,
        multiple: false,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    $(".automatic-actions .dropdownlistuseroperatorValue").select2({
        minimumInputLength: 0,
        multiple: false,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                    includeEndUsers: false,
                    includeSmartUsers: false,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    $(".automatic-actions .select2-user").select2({
        placeholder: Localization_Search,
        minimumInputLength: 0,
        allowClear: false,
        multiple: true,
        tags: true,
        /*width: 'auto',*/
        dropdownAutoWidth: true,
        tokenSeparators: [',', ';', ' '],
        createTag: function (tag) { //pro vlastni tagy
            if (isValidEmailAddress(tag.term)) { //kontrola validni email adresy
                return {
                    id: tag.term,
                    text: tag.term
                };
            }
            else return null;
        },
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                if (data.PageNum == 1) {
                    $(specialSendToValues).each(function () {
                        data.Results.unshift({ id: this.Value, text: this.Text });
                    });
                }

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    if ($(".automatic-actions div.tinymce-inline").length > 0) {
        tinymce.init({
            selector: ".automatic-actions div.tinymce-inline",
            cache_suffix: "?ver=" + ver,
            theme: "silver",
            plugins: [
                "autoresize advlist autolink lists link image charmap print preview anchor",
                "searchreplace visualblocks code fullscreen",
                "insertdatetime media table paste textcolor"
            ],
            toolbar1: "insertfile undo redo | styleselect | bold italic | forecolor backcolor | link image",
            toolbar2: "alignleft aligncenter alignright alignjustify | bullist numlist outdent indent",
            entity_encoding: "raw",
            convert_fonts_to_spans: true,
            paste_data_images: true,
            language: language,
            branding: false,
            contextmenu: false,
            inline: true,
            setup: function (editor) {
                editor.on('change', function (e) {
                    $(tinymce.activeEditor.selection.getNode()).closest(".form-group").find(".textValue").val(editor.getContent());
                });
            }
        });
    }
    $.each($('.colorValue'), function (index, value) {
        var colorValue = $(value).val();
        $(value).closest('.change-color').initColorpicker();
        $(value).closest('.change-color').colorpicker('setValue', colorValue);
    });
}