﻿$(document).ready(function () {
    $('#coloPickerDiv').initColorpicker();

    $("#myForm").validate();
    $("#EventFromDate").rules("add", { date: true });
    $("#EventToDate").rules("add", { date: true });
    $(".datepicker").datepicker();
    $(".timepicker").timepicker();
    $("#AllDay").change(function () {
        checkAllDay();
    });

    $("#EventClassicAllDay").change(function () {
        checkEventClassicAllDay();
    });

    $("body").on("click", ".eventEdit", function () {
        $.ajax({
            url: RQ_URL + '/CalendarScheduler/GetDataById',
            data: JSON.stringify({
                id: $(this).data("id"),
            }),
            type: "POST",
            contentType: "application/json; charset=utf-8",
            success: function (event) {
                if (event.eventType == 1) {
                    editUnavailability(event.id, event.description, event.userProviderKey, event.type, event.allDay, event.start, event.endForEdit, event.calendarId, event.sendReminderForEveryone, event.reminders);
                }
                else if (event.eventType == 2) {
                    editEventClassic(event.id, event.description, event.allDay, event.start, event.endForEdit, event.location, event.color, event.title, event.calendarId, event.sendReminderForEveryone, event.reminders, event.type, event.ticketIds, event.tickets);
                }
            },
            error: function (error) {
                alert(error.responseText);
            },
        });
    });

    $("#AllCalendarSchedulers").on("change", ".calendar-scheduler input[type=checkbox]", function () {
        $.ajax({
            url: RQ_URL + '/CalendarScheduler/SetCalendarSelection',
            data: JSON.stringify({
                Selected: $(this).is(":checked"),
                CalendarId: $(this).val(),
            }),
            type: "POST",
            contentType: "application/json; charset=utf-8",
            success: function (event) {
            },
            error: function (error) {
                alert(error.responseText);
            },
        });
        reloadData();
    });

    $("input:radio[name='RepresentationType']").change(function () {
        var value = $('input[name="RepresentationType"]:checked').val();
        if (value == 2) {
            $("#CrowdOperator").prop("disabled", false);
        }
        else {
            $("#CrowdOperator").prop("disabled", true);
        }
    });

    $("#OperatorsAvailability").on("click", ".calendar-scheduler-operators-availability-div", function () {
        eventId = $(this).data("id");
        showEvent(eventId, 1);
    });

    $("#FilterOperator").on("change", function (e) {
        if (calendar) {
            $('#calendar-scheduler').fullCalendar('refetchEvents');
        }
        else {
            loadOperatorsAvailability(month, year);
        }
    });

    $("#Type").on("change", function (e) {
        $("#EventType-error").hide();
        if ($("#Type").val() == null) {
            $("#EventType-error").show();
            $("#EventType-error").text(Localization_CalendarScheduler_PleaseSelectTypeOfUnavailability);
        }
    });

    $("#EventFromDate").change(function () { validDate() });
    $("#EventToDate").change(function () { validDate() });
    $("#EventFromTime").change(function () { validDate() });
    $("#EventToTime").change(function () { validDate() });

    $("#FilterOperatorGroup").on("change", function (e) {
        if (calendar) {
            $('#calendar-scheduler').fullCalendar('refetchEvents');
        }
        else {
            loadOperatorsAvailability(month, year);
        }
    });

    $("#dialog-create-new-event").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text: Localization_Save,
            id: "CreateNewEventSaveButton",
            click: function () {
                var number = new RegExp(/^([0-9]{2})\:([0-9]{2})$/);
                if (!$("#EventClassicFromDate").valid() || !$("#EventClassicToDate").valid() ||
                    $("#EventClassicFromDate").val() == "" || $("#EventClassicToDate").val() == "") {
                    if (!$("#EventClassicFromDate").valid() || $("#EventClassicFromDate").val() == "") {
                        $("#EventClassicFromDate-error").show();
                        $("#EventClassicFromDate-error").text();
                    }
                    if (!$("#EventClassicToDate").valid() || $("#EventClassicToDate").val() == "") {
                        $("#EventClassicToDate-error").show();
                        $("#EventClassicToDate-error").text(Localization_CalendarScheduler_PleaseEnterValidDate);
                    }
                }
                else if (!$("#EventClassicAllDay").prop("checked") && (
                    (!number.test($("#EventClassicFromTime").val()) || $("#EventClassicFromTime").val() == "")
                    || (!number.test($("#EventClassicToTime").val()) || $("#EventClassicToTime").val() == ""))) {
                    if (!number.test($("#EventClassicFromTime").val()) || $("#EventClassicFromTime").val() == "") {
                        $("#EventClassicFromTime-error").show();
                        $("#EventClassicFromTime-error").text(Localization_CalendarScheduler_PleaseEnterValidTime);
                    }
                    if (!number.test($("#EventClassicToTime").val()) || $("#EventClassicToTime").val() == "") {
                        $("#EventClassicToTime-error").show();
                        $("#EventClassicToTime-error").text(Localization_CalendarScheduler_PleaseEnterValidTime);
                    }
                }
                else if ($("#EventClassicFromDate").datepicker("getDate") > $("#EventClassicToDate").datepicker("getDate")) {
                    $("#EventClassicToMustBe-error").show();
                    $("#EventClassicToMustBe-error").text(Localization_CalendarScheduler_DatumFromMustBeGreaterThanDateUntil);
                }
                else if (!$("#EventClassicAllDay").prop("checked") && ($("#EventClassicFromDate").val() == $("#EventClassicToDate").val() && convertNumber($("#EventClassicFromTime").timepicker('getTime')) > convertNumber($("#EventClassicToTime").timepicker('getTime')))) {
                    $("#EventClassicToMustBeTime-error").show();
                    $("#EventClassicToMustBeTime-error").text(Localization_CalendarScheduler_TimeFromMustBeGreaterThanTimeUntil);
                }
                else if ($("#EventClassicCalendars").val() == null) {
                    $("#EventClassicCalendarsError").show();
                }
                else {
                    var dateStart = $("#EventClassicFromDate").val();
                    var dateStartTime = $("#EventClassicFromTime").timepicker('getTime')
                    var dateEnd = $("#EventClassicToDate").val();
                    var dateEndTime = $("#EventClassicToTime").timepicker('getTime');
                    $.ajax({
                        url: RQ_URL + '/CalendarScheduler/AddEvent',
                        type: "POST",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({
                            id: $("#eventClassicId").val(),
                            location: $("#EventClassicLocation").val(),
                            name: $("#EventClassicName").val(),
                            description: $("#EventClassicDescription").val(),
                            allDay: $("#EventClassicAllDay").prop("checked"),
                            color: $("#ColorCalendarScheduler").val(),
                            calendarId: $("#EventClassicCalendars").val(),
                            sendReminderForEveryone: $("#RemindeEverybodyEventClassic").is(":checked"),
                            reminderCollection: createReminderCollection("#divRemindersEventClassic"),
                            typeId: $("#EventClassicType").val(),
                            startDate: dateStart,
                            startTime: dateStartTime,
                            endDate: dateEnd,
                            endTime: dateEndTime,
                            ticketIds: $("#EventClassicTickets").val()
                        }),
                        success: function (g) {
                            ShowSuccess(Localization_CalendarSchedular_Event + ": " + g.Name + " " + g.StartDate + " - " + g.EndDate + " <a data-id='" + g.Id + "' href='javascript:void(0)' class='eventEdit'>" + Localization_Edit + "</a>");
                            reloadData();
                        },
                        error: function (error) {
                            alert(error.responseText);
                        },
                    });
                    $("#dialog-create-new-event").dialog("close");
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $("#dialog-create-new-event").dialog("close");
            }
        }]
    });

    $("#divReminders").on('click', 'a.remove', function () {
        $(this).closest('div.text-with-hiding-buttons').remove();
    });

    $('#divReminders').on("click", ".btn-plus", function () {
        var hiddenPhonesNextIndex = $('#hiddenRemindersNextIndex');
        var index = parseInt(hiddenPhonesNextIndex.val());

        var html = $("#ReminderTemplate").html();

        $('#divReminders').append(html);
        $("#EventCalendars").trigger("change");
        hiddenPhonesNextIndex.val(index + 1);
    });

    $("#divRemindersEventClassic").on('click', 'a.remove', function () {
        $(this).closest('div.text-with-hiding-buttons').remove();
    });

    $('#divRemindersEventClassic').on("click", ".btn-plus", function () {
        var html = $("#ReminderTemplate").html();

        $('#divRemindersEventClassic').append(html);
        $("#EventClassicCalendars").trigger("change");
    });

    $("body").on("change","#EventCalendars",function () {
        if ($("option:selected", this).data("share") == "True") {
            $(".shared-calendar").show();
            $('select.reminder-type option[value="' + optionEmailValue + '"]').text(Localization_Email);
        }
        else {
            $(".shared-calendar").hide();
            $('select.reminder-type option[value="' + optionEmailValue + '"]').text(Localization_Email + " " + myEmail.replace("()",""));
        }
    });

    $("body").on("change","#EventClassicCalendars",function () {
        if ($("option:selected", this).data("share") == "True") {
            $(".shared-calendar").show();
            $('select.reminder-type option[value="' + optionEmailValue + '"]').text(Localization_Email);
        }
        else {
            $(".shared-calendar").hide();
            $('select.reminder-type option[value="' + optionEmailValue + '"]').text(Localization_Email + " " + myEmail.replace("()", ""));
        }
    });

    $("#dialog-create-new-unavaible").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text: Localization_Save,
            id: "CreateNewUnavaibleSaveButton",
            click: function () {
                var number = new RegExp(/^([0-9]{2})\:([0-9]{2})$/);
                $("#EventType-error").hide();
                if (!$("#EventFromDate").valid() || !$("#EventToDate").valid() ||
                    $("#EventFromDate").val() == null || $("#EventFromDate").val() == undefined || $("#EventFromDate").val() == "" ||
                    $("#EventToDate").val() == null || $("#EventToDate").val() == undefined || $("#EventToDate").val() == "") {
                    if (!$("#EventFromDate").valid() || $("#EventFromDate").val() == "") {
                        $("#EventFromDate-error").show();
                        $("#EventFromDate-error").text(Localization_CalendarScheduler_PleaseEnterValidDate);
                    }
                    if (!$("#EventToDate").valid() || $("#EventToDate").val() == "") {
                        $("#EventToDate-error").show();
                        $("#EventToDate-error").text(Localization_CalendarScheduler_PleaseEnterValidDate);
                    }
                }
                else if (!$("#AllDay").prop("checked") && (
                    (!number.test($("#EventFromTime").val()) || $("#EventFromTime").val() == null || $("#EventFromTime").val() == undefined || $("#EventFromTime").val() == "")
                    || (!number.test($("#EventToTime").val()) || $("#EventToTime").val() == null || $("#EventToTime").val() == undefined || $("#EventToTime").val() == ""))) {
                    if (!number.test($("#EventFromTime").val()) || $("#EventFromTime").val() == null || $("#EventFromTime").val() == undefined || $("#EventFromTime").val() == "") {
                        $("#EventFromTime-error").show();
                        $("#EventFromTime-error").text(Localization_CalendarScheduler_PleaseEnterValidTime);
                    }
                    if (!number.test($("#EventToTime").val()) || $("#EventToTime").val() == null || $("#EventToTime").val() == undefined || $("#EventToTime").val() == "") {
                        $("#EventToTime-error").show();
                        $("#EventToTime-error").text(Localization_CalendarScheduler_PleaseEnterValidTime);
                    }
                }
                else if ($("#EventFromDate").datepicker("getDate") > $("#EventToDate").datepicker("getDate")) {
                    $("#EventToMustBe-error").show();
                    $("#EventToMustBe-error").text(Localization_CalendarScheduler_DatumFromMustBeGreaterThanDateUntil);
                }
                else if (!$("#AllDay").prop("checked") && ($("#EventFromDate").val() == $("#EventToDate").val() && convertNumber($("#EventFromTime").timepicker('getTime')) > convertNumber($("#EventToTime").timepicker('getTime')))) {
                    $("#EventToMustBeTime-error").show();
                    $("#EventToMustBeTime-error").text(Localization_CalendarScheduler_TimeFromMustBeGreaterThanTimeUntil);
                }
                else if($("#EventCalendars").val() == null){
                    $("#EventCalendarsError").show();
                }
                else {
                    var dateStart = $("#EventFromDate").val();
                    var dateStartTime = $("#EventFromTime").timepicker('getTime')
                    var dateEnd = $("#EventToDate").val();
                    var dateEndTime = $("#EventToTime").timepicker('getTime');
                    $.ajax({
                        url: RQ_URL + '/CalendarScheduler/AddUnavaible',
                        type: "POST",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({
                            id: $("#unavailabilityId").val(),
                            description: $("#EventDescription").val(),
                            allDay: $("#AllDay").prop("checked"),
                            typeId: $("#Type").val(),
                            userProviderKey: $("#Operator").val(),
                            calendarId: $("#EventCalendars").val(),
                            sendReminderForEveryone: $("#RemindeEverybody").is(":checked"),
                            reminderCollection: createReminderCollection("#divReminders"),
                            startDate: dateStart,
                            startTime: dateStartTime,
                            endDate: dateEnd,
                            endTime: dateEndTime,
                        }),
                        success: function (g) {
                            ShowSuccess("Nedostupnost: " + g.Name + " " + g.StartDate + " - " + g.EndDate + " <a data-id='" + g.Id + "' href='javascript:void(0)' class='eventEdit'>Upravit</a>");
                            reloadData();
                        },
                        error: function (error) {
                            alert(error.responseText);
                        },
                    });
                    $("#dialog-create-new-unavaible").dialog("close");
                }
            }
        }, {
            text: Localization_Close,
            click : function () {
                $("#dialog-create-new-unavaible").dialog("close");
            }
        }]
    });

    $("#dialog-select-event-classic-action").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 500
    });

    $("#dialog-select-action").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 500
    });

    $("#dialog-set-crowd").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text: Localization_Save,
            click: function () {
                if ($("input:radio[name='RepresentationType']:checked").val() == 2 && $("#CrowdOperator").val() == null) {
                    $("#CrowdOperatorError").show();
                    $("#CrowdOperatorError").text(Localization_CalendarScheduler_MustSelectOperator);
                }
                else {
                    $.ajax({
                        url: RQ_URL + '/CalendarScheduler/SetCrowded',
                        type: "POST",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({
                            id: $("#crowdId").val(),
                            type: $("input:radio[name='RepresentationType']:checked").val(),
                            representationUserProviderKey: $("#CrowdOperator").val(),
                        }),
                        success: function (g) {
                            reloadData();
                            $("#dialog-set-crowd").dialog("close");
                        },
                        error: function (error) {
                            alert(error.responseText);
                        },
                    });
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $("#dialog-set-crowd").dialog("close");
            }
        }]
    });

    $('#calendar-scheduler').fullCalendar({
        header: {
            left: 'prev,next today',
            center: 'title',
            right: 'month,agendaWeek,agendaDay'
        },
        lang: language,
        defaultDate: Date.now(),
        height: 600,
        timezone: userTimeZone,
        selectable: true,
        selectHelper: true,
        eventClick: function (calEvent, jsEvent, view) {
            showEvent(calEvent.id, calEvent.eventType);
        },
        editable: true,
        eventLimit: true, // allow "more" link when too many events
        eventRender: function (event, element) {
            if (event.eventType == 1) {
                if (event.hasCrowd) {
                    element.find(".fc-content").prepend("<i class='fa fa-user' aria-hidden='true'></i> ");
                }
                element.find(".fc-content").prepend("<i class='fa fa-user-times' aria-hidden='true'></i> ");
            }
            else if (event.eventType == 2) {
                element.find(".fc-content").prepend("<i class='fa fa-calendar-o' aria-hidden='true'></i>");
            }
            if (event.type != null) { // kategorie
                element.prepend("<div class='right calendar-right-box' style='background-color:" + event.unavailabitlityBackgroundColor + ";border-color:" + event.unavailabitlityBorderColor + "'></div>");
            }
            element.find(".fc-content").after("<div style='clear:both;'></div>");
        },
        eventSources: [
            // your ajax event source
            {
                events: function (start, end, timezone, callback) {
                    var values = new Array();
                    $(".calendar-scheduler input[type=checkbox]:checked").each(function () {
                        values.push($(this).val());
                    });
                    $.ajax({ //posle dotaz na server
                        url: RQ_URL + '/CalendarScheduler/GetData',
                        type: 'POST',
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({ //kvuli tomu je to zde, ten fullcalendar standardne neposila JSON, ale jen string a ASP.NET MVC to spravne nebinduje
                            start: start,
                            end: end,
                            calendars: values
                        }),
                        success: function (data) {
                            callback(data); //nacte vysledek do kalendare
                        },
                        error: function (error) {
                            alert(error.responseText);
                        },
                    });
                    $.ajax({ //posle dotaz na server
                        url: RQ_URL + '/CalendarScheduler/GetCategories',
                        type: 'POST',
                        contentType: "application/json; charset=utf-8",
                        dataType: "html",
                        data: JSON.stringify({
                            start: start,
                            end: end,
                            calendars: values
                        }),
                        success: function (data) {
                            $("#CategoryTypes").html(data);
                        },
                        error: function (error) {
                            alert(error.responseText);
                        },
                    });
                }
            },
            {
                borderColor: 'black',
                color: 'yellow',   // a non-ajax option
                textColor: 'black' // a non-ajax option
            }
        ],
        eventResize: function (event, delta, revertFunc) {
            //alert(event.start);
            changeDate(event.id, event.start, event.end, event.allDay);
        },
        eventDrop: function (event, delta, revertFunc) {
            //alert(event.start);
            changeDate(event.id, event.start, event.end == null ? event.start : event.end, event.allDay);
        },
        select: function (start, end, ev) {
            startDateFromCalendar = start;
            endDateFromCalendar = new Date(end);
            endDateFromCalendar.setDate(endDateFromCalendar.getDate() - 1);
        },
        unselect: function (ev) {
            clearTimeout(typingTimer);
            typingTimer = setTimeout(function () {
                endDateFromCalendar = null;
                startDateFromCalendar = null;
            }, doneTypingInterval);
        },
    });

    $("#dialog-calendar").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            id: "CalendarSaveButton",
            text: Localization_Save,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/CalendarScheduler/NewOrUpdateCalendar',
                    data: JSON.stringify({
                        Id: calendarSchedulerId,
                        Name: $("#NameCalendarScheduler").val(),
                        Description: $("#DescriptionCalendarScheduler").val(),
                        Hex: $("#ColorCalendarScheduler").val(),
                        Share: $("#ShareCalendarScheduler").is(":checked"),
                        ShareType: $('input[name=ShareTypeCalendarScheduler]:checked').val(),
                        Operators: $("#OperatorsCalendarScheduler").val(),
                        OperatorGroups: $("#OperatorGroupsCalendarScheduler").val(),
                        OthersCanAddNewEvent: $("#OthersCanAddNewEventCalendarScheduler").is(":checked"),
                        OthersCanEditAllEvents: $("#OthersCanEditAllEventsCalendarScheduler").is(":checked"),
                        EnableOnlineExport: $("#ShareCalendarSchedulerIcal").is(":checked"),
                        UniqueId: $("#CalendarSchedulerUniqueId").val()
                    }),
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    success: function (event) {
                        $("#dialog-calendar").dialog("close");
                        reloadCalendarSchedulers();
                    },
                    error: function (error) {
                        alert(error.responseText);
                    },
                });
            }
        }, {
            text: Localization_Close,
            click: function () {
                if (onlineExportValue != null && onlineExportValue != $("#ShareCalendarSchedulerIcal").is(":checked")) {
                    setShareCalendarSchedulerIcal(onlineExportValue);
                }
                $("#dialog-calendar").dialog("close");
            }
        }]
    });

    $("#dialog-calendar-scheduler-delete").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/CalendarScheduler/DeleteCalendarScheduler',
                    data: JSON.stringify({
                        Id: calendarSchedulerId,
                    }),
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    success: function (event) {
                        $("#dialog-calendar-scheduler-delete").dialog("close");
                        reloadCalendarSchedulers();
                    },
                    error: function (error) {
                        alert(error.responseText);
                    },
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                $("#dialog-calendar-scheduler-delete").dialog("close");
            }
        }]
    });

    $("#ShareCalendarScheduler").change(function () {
        $(".share-type-calendar-scheduler").toggle($(this).is(":checked"));
    });

    $("#OthersCanAddNewEventCalendarScheduler").change(function () {
        if ($(this).is(":checked")) {
            $("#OthersCanEditAllEventsCalendarScheduler").prop("disabled", false);
        }
        else {
            $("#OthersCanEditAllEventsCalendarScheduler").prop("disabled", true);
            $("#OthersCanEditAllEventsCalendarScheduler").prop("checked", false);
        }
    });

    $("#ShareCalendarSchedulerIcal").change(function () {
        $(".share-type-calendar-scheduler-ical").toggle($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $.ajax({
                url: RQ_URL + '/CalendarScheduler/CalendarSchedulerGetUniqueId',
                data: {
                    Id: calendarSchedulerId,
                },
                type: "GET",
                contentType: "application/json; charset=utf-8",
                success: function (event) {
                    $("#CalendarSchedulerUniqueId").val(event.id);
                    $("#ShareCalendarIcalLink").html("<a href='" + event.url + "'><small>" + event.url + "</small></a>");
                },
                error: function (error) {
                    alert(error.responseText);
                },
            });
        }
        else {
            setShareCalendarSchedulerIcal($(this).is(":checked"));
        }
    });

    $("#SelectedOperatorsCalendarScheduler").change(function () {
        $("#OperatorGroupsCalendarScheduler").prop("disabled", !$("#SelectedOperatorsCalendarScheduler").is(":checked"));
        $("#OperatorsCalendarScheduler").prop("disabled", !$("#SelectedOperatorsCalendarScheduler").is(":checked"));
    });

    $("#AllOperatorsCalendarScheduler").change(function () {
        $("#OperatorGroupsCalendarScheduler").prop("disabled", !$("#SelectedOperatorsCalendarScheduler").is(":checked"));
        $("#OperatorsCalendarScheduler").prop("disabled", !$("#SelectedOperatorsCalendarScheduler").is(":checked"));
    });
    
    $("body").on("click", ".delete-calendar-scheduler", function () {
        calendarSchedulerId = $(this).closest(".calendar-scheduler").data("id");
        $("#dialog-calendar-scheduler-delete").dialog("open");
    });

    $("body").on("click", ".edit-calendar-scheduler", function () {
        calendarSchedulerId = $(this).closest(".calendar-scheduler").data("id");
        editCalendar();
    });

    $("body").on("click", ".delete-calendar-scheduler-table", function () {
        calendarSchedulerId = $(this).data("id");
        $("#dialog-calendar-scheduler-delete").dialog("open");
    });

    $("body").on("click", ".edit-calendar-scheduler-table", function () {
        calendarSchedulerId = $(this).data("id");
        editCalendar();
    });

    $("#dialog-calendar-scheduler-manage").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text: Localization_Close,
            click: function () {
                $("#dialog-calendar-scheduler-manage").dialog("close");
            }
        }]
    });
});

var calendarSchedulerId = -1;

function setShareCalendarSchedulerIcal(value) {
    if (calendarSchedulerId != -1 && calendarSchedulerId != null) {
        $.ajax({
            url: RQ_URL + '/CalendarScheduler/SetShareCalendarSchedulerIcal',
            data: JSON.stringify({
                id: calendarSchedulerId,
                value: value
            }),
            type: "POST",
            contentType: "application/json; charset=utf-8",
            success: function (event) {
            },
            error: function (error) {
                alert(error.responseText);
            },
        });
    }
}

function createReminderCollection(id) {
    var result = new Array();
    $.each($(id).find(".text-with-hiding-buttons"), function( key, value ) {
        result.push({ Id: $(value).find(".reminder-type").data("id"), Type: $(value).find(".reminder-type").val(), Time: $(value).find(".reminder-time").val() });
    });
    return result;
}

function manageCalendars() {
    $("#dialog-calendar-scheduler-manage").dialog("open");
    $("#dialog-calendar-scheduler-manage").html("<div class='loading-32'></div>");
    $("#dialog-calendar-scheduler-manage").load(RQ_URL + "/CalendarScheduler/AllCalendarSchedulersTable", function () {
        $("#dialog-calendar-scheduler-manage").dialog("close");
        $("#dialog-calendar-scheduler-manage").dialog("open");
    });
}

var onlineExportValue = null;

function editCalendar() {
    OnAjaxBegin("Načítám...");
    $.ajax({
        url: RQ_URL + '/CalendarScheduler/GetCalendarSchedulerInformation/' + calendarSchedulerId,
        type: "GET",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            OnAjaxComplete();
            $("#NameCalendarScheduler").val(g.Name);
            $("#DescriptionCalendarScheduler").val(g.Description);
            $("#ColorCalendarScheduler").val(g.Color);
            $("#coloPickerDiv").colorpicker("setValue", g.Color);
            $("#ColorCalendarScheduler").trigger("change");
            $("#ShareCalendarScheduler").prop('checked', g.Share);
            $("#ShareCalendarScheduler").trigger("change");
            $("#AllOperatorsCalendarScheduler").prop('checked', g.ShareType == null || g.ShareType == 1);
            $("#AllOperatorsCalendarScheduler").trigger("change");
            $("#SelectedOperatorsCalendarScheduler").prop('checked', g.ShareType == 2);
            $("#SelectedOperatorsCalendarScheduler").trigger("change");
            $("#OthersCanAddNewEventCalendarScheduler").prop('checked', g.OthersCanAddNewEvent);
            $("#OthersCanAddNewEventCalendarScheduler").trigger("change");
            $("#OthersCanEditAllEventsCalendarScheduler").prop('checked', g.OthersCanEditAllEvents);
            $("#ShareCalendarSchedulerIcal").prop('checked', g.EnableOnlineExport);
            onlineExportValue = g.EnableOnlineExport;
            $("#ShareCalendarSchedulerIcal").trigger("change");
            $("#CalendarSchedulerUniqueId").val(g.UniqueId);
            var users = new Array();
            $.each(g.CalendarSchedulerUsers, function (index, value) {
                users.push(value.UserProviderKey);
            });
            $("#OperatorsCalendarScheduler").val(users).trigger("change");
            var operatorGroups = new Array();
            $.each(g.OperatorGroups, function (index, value) {
                operatorGroups.push(value.Id);
            });
            $("#OperatorGroupsCalendarScheduler").val(operatorGroups).trigger("change");
            $('#CalendarSaveButton').button('option', 'label', Localization_Save);
            $('#dialog-calendar').dialog('option', 'title', Localization_CalendarScheduler_EditCalendar);
            $("#dialog-calendar").dialog("open");
        },
        error: function (error) {
            alert(error.responseText);
        },
    });
}

function addNewCalendar() {
    onlineExportValue = null;
    calendarSchedulerId = null;
    var colors = new Array('#ffffcc', '#f0ad4e', '#5cb85c', '#5bc0de', '#337ab7', '#d9534f', '#b90600', '#ec2b8c', '#763f98', '#7f7f7f', '#7B3F00');
    $("#NameCalendarScheduler").val("");
    $("#DescriptionCalendarScheduler").val("");
    $("#ColorCalendarScheduler").val(colors[$("#AllCalendarSchedulers .calendar-scheduler").length]);
    $("#coloPickerDiv").colorpicker("setValue", colors[$("#AllCalendarSchedulers .calendar-scheduler").length]);
    $("#ColorCalendarScheduler").trigger("change");
    $("#OperatorsCalendarScheduler").val("").trigger("change");
    $("#OperatorGroupsCalendarScheduler").val("").trigger("change");
    $("#OthersCanAddNewEventCalendarScheduler").prop('checked', false);
    $("#OthersCanAddNewEventCalendarScheduler").trigger("change");
    $("#OthersCanEditAllEventsCalendarScheduler").prop('checked', false);
    $("#ShareCalendarScheduler").prop('checked', false);
    $("#ShareCalendarScheduler").trigger("change");
    $("#ShareCalendarSchedulerIcal").prop('checked', false);
    $("#ShareCalendarSchedulerIcal").trigger("change");
    $(".share-type-calendar-scheduler").hide();
    $("#AllOperatorsCalendarScheduler").prop('checked', true);
    $("#AllOperatorsCalendarScheduler").trigger("change");
    $("#CalendarSchedulerUniqueId").val("");
    $('#CalendarSaveButton').button('option', 'label', Localization_Create);
    $('#dialog-calendar').dialog('option', 'title', Localization_CalendarScheduler_NewCalendar);
    $("#dialog-calendar").dialog("open");
}

var typingTimer;
var doneTypingInterval = 4000;
var startDateFromCalendar = null;
var endDateFromCalendar = null;

function checkEventClassicAllDay() {
    if($("#EventClassicAllDay").prop("checked")) {
        $(".timepicker").prop("disabled", true);
        var dateNow = new Date(Date.now());
        dateNow.setMinutes(0);
        $("#EventClassicFromTime").timepicker("setTime", dateNow);
        dateNow.setHours(dateNow.getHours() + 1);
        $("#EventClassicToTime").timepicker("setTime", dateNow);
    }
    else {
        $(".timepicker").prop("disabled", false);
    }
}

function checkAllDay() {
    if ($("#AllDay").prop("checked")) {
        $(".timepicker").prop("disabled", true);
        var dateNow = new Date(Date.now());
        dateNow.setMinutes(0);
        $("#EventFromTime").timepicker("setTime", dateNow);
        dateNow.setHours(dateNow.getHours() + 1);
        $("#EventToTime").timepicker("setTime", dateNow);
    }
    else {
        $(".timepicker").prop("disabled", false);
    }
}

function reloadData() {
    if (calendar) {
        $('#calendar-scheduler').fullCalendar('refetchEvents');
    }
    else {
        loadOperatorsAvailability(month, year);
    }
}

var calendar = true;
var month = 0;
var year = 0;
var eventId = 0;
var loadedEvent;

function validDate() {
    $("#EventFromDate-error").hide();
    $("#EventToDate-error").hide();
    $("#EventFromTime-error").hide();
    $("#EventToTime-error").hide();
    $("#EventToMustBe-error").hide();
    $("#EventToMustBeTime-error").hide();
    if (!$("#EventFromDate").valid() || !$("#EventToDate").valid() ||
                    $("#EventFromDate").val() == null || $("#EventFromDate").val() == undefined || $("#EventFromDate").val() == "" ||
                    $("#EventToDate").val() == null || $("#EventToDate").val() == undefined || $("#EventToDate").val() == "") {
        if (!$("#EventFromDate").valid() || $("#EventFromDate").val() == "") {
            $("#EventFromDate-error").show();
            $("#EventFromDate-error").text(Localization_CalendarScheduler_PleaseEnterValidDate);
        }
        if (!$("#EventToDate").valid() || $("#EventToDate").val() == "") {
            $("#EventToDate-error").show();
            $("#EventToDate-error").text(Localization_CalendarScheduler_PleaseEnterValidDate);
        }
    }
    else if (!$("#AllDay").prop("checked") && (
        (!number.test($("#EventFromTime").val()) || $("#EventFromTime").val() == null || $("#EventFromTime").val() == undefined || $("#EventFromTime").val() == "")
        || (!number.test($("#EventToTime").val()) || $("#EventToTime").val() == null || $("#EventToTime").val() == undefined || $("#EventToTime").val() == ""))) {
        if (!number.test($("#EventFromTime").val()) || $("#EventFromTime").val() == null || $("#EventFromTime").val() == undefined || $("#EventFromTime").val() == "") {
            $("#EventFromTime-error").show();
            $("#EventFromTime-error").text(Localization_CalendarScheduler_PleaseEnterValidTime);
        }
        if (!number.test($("#EventToTime").val()) || $("#EventToTime").val() == null || $("#EventToTime").val() == undefined || $("#EventToTime").val() == "") {
            $("#EventToTime-error").show();
            $("#EventToTime-error").text(Localization_CalendarScheduler_PleaseEnterValidTime);
        }
    }
    else if ($("#EventFromDate").datepicker("getDate") > $("#EventToDate").datepicker("getDate")) {
        $("#EventToMustBe-error").show();
        $("#EventToMustBe-error").text(Localization_CalendarScheduler_DatumFromMustBeGreaterThanDateUntil);
    }
    else if (!$("#AllDay").prop("checked") && ($("#EventFromDate").val() == $("#EventToDate").val() && convertNumber($("#EventFromTime").timepicker('getTime')) > convertNumber($("#EventToTime").timepicker('getTime')))) {
        $("#EventToMustBeTime-error").show();
        $("#EventToMustBeTime-error").text(Localization_CalendarScheduler_TimeFromMustBeGreaterThanTimeUntil);
    }
}

function getData(id) {
    OnAjaxBegin(Localization_CalendarScheduler_LoadingData);
    $.ajax({
        url: RQ_URL + '/CalendarScheduler/GetDataById?id=' + id,
        type: "GET",
        contentType: "application/json; charset=utf-8",
        success: function (event) {
            if (event === false) {
                reloadData();
            }
            else {
                loadedEvent = event;
                $("#ActionsFrom").text("");
                $("#ActionsTo").text("");
                $("#ActionsWho").text("");
                if (event.allDay) {
                    $("#ActionsFrom").text(moment.utc(event.start).locale(language).format('l'));
                    $("#ActionsTo").text(moment.utc(event.endForEdit).locale(language).format('l'));
                }
                else {
                    $("#ActionsFrom").text(moment.utc(event.start).locale(language).format('l LT'));
                    $("#ActionsTo").text(moment.utc(event.endForEdit).locale(language).format('l LT'));
                }
                $("#ActionsWho").text(event.fullName);
                if (event.canEdit) {
                    $("#dialog-select-action button").show();
                }
                else {
                    $("#dialog-select-action button").hide();
                }
                $("#dialog-select-action").dialog("open");
            }
            OnAjaxComplete();
        },
        error: function (error) {
            alert(error.responseText);
        },
    });
}

function showCalendar() {
    calendar = true;
    $("#Calendar").show();
    $("#OperatorsAvailability").hide();
    reloadData();
}

function showOperatorsAvailability() {
    calendar = false;
    $("#Calendar").hide();
    $("#OperatorsAvailability").show();
    var dt = new Date();
    loadOperatorsAvailability(dt.getMonth() + 1, dt.getFullYear());
}

function loadOperatorsAvailability(month, year) {
    if (month != 0 && year != 0) {
        OnAjaxBegin(Localization_CalendarScheduler_LoadingCalendar);
        var values = new Array();
        $(".calendar-scheduler input[type=checkbox]:checked").each(function () {
            values.push($(this).val());
        });
        $.ajax({
            type: 'POST',
            url: RQ_URL + "/CalendarScheduler/OperatorsAvailability",
            data: JSON.stringify({
                month: month,
                year: year,
                calendars: values
            }),
            contentType: 'application/json; charset=utf-8',
            success: function (data) {
                OnAjaxComplete();
                $("#OperatorsAvailability").html(data);
            },
            error: function (error) {
                alert(error.responseText);
            },
        });
        $.ajax({ //posle dotaz na server
            url: RQ_URL + '/CalendarScheduler/GetCategoriesUnavailability',
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            dataType: "html",
            data: JSON.stringify({
                month: month,
                year: year,
                calendars: values
            }),
            success: function (data) {
                $("#CategoryTypes").html(data);
            },
            error: function (error) {
                alert(error.responseText);
            },
        });

    }
}

function selectAction(type) {
    $("#dialog-select-action").dialog("close");
    $("#dialog-select-event-classic-action").dialog("close");

    if (calendar) {
        var event = $("#calendar-scheduler").fullCalendar('clientEvents', evId)[0];
        if (type == 1 && event.canEdit) {
            editUnavailability(event.id, event.description, event.userProviderKey, event.type, event.allDay, event.start, event.endForEdit, event.calendarId, event.sendReminderForEveryone, event.reminders);
        }
        else if (type == 2 && event.canEdit) {
            deleteEvent(event.id, event.eventType);
        }
        else if (type == 3 && event.canEdit) {
            setCrowd(event.id, event.fullName, event.start, event.endForEdit, event.representationUserProviderKey, event.representationType, event.typeName, event.allDay);
        }
        else if (type == 4 && event.canEdit) {
            editEventClassic(event.id, event.description, event.allDay, event.start, event.endForEdit, event.location, event.color, event.title, event.calendarId, event.sendReminderForEveryone, event.reminders, event.type, event.ticketIds, event.tickets);
        }
    }
    else {
        selectType(loadedEvent, type);
    }
}

function selectType(event, type) {
    if (type == 1 && event.canEdit) {
        editUnavailability(event.id, event.description, event.userProviderKey, event.type, event.allDay, event.start, event.endForEdit, event.calendarId, event.sendReminderForEveryone, event.reminders);
    }
    else if (type == 2 && event.canEdit) {
        deleteEvent(event.id, event.eventType);
    }
    else if (type == 3 && event.canEdit) {
        setCrowd(event.id, event.fullName, event.start, event.endForEdit, event.representationUserProviderKey, event.representationType, event.typeName, event.allDay);
    }
}

var evId = 0;

function showEvent(eventId, type) {
    evId = eventId;
    if (calendar) {
        var event = $("#calendar-scheduler").fullCalendar('clientEvents', evId)[0];
        if (type == 1) {
            $("#ActionsFrom").text("");
            $("#ActionsTo").text("");
            $("#ActionsWho").text("");
            if (event.allDay) {
                $("#ActionsFrom").text(moment.utc(event.start).locale(language).format('l'));
                $("#ActionsTo").text(moment.utc(event.endForEdit).locale(language).format('l'));
            }
            else {
                $("#ActionsFrom").text(moment.utc(event.start).locale(language).format('l LT'));
                $("#ActionsTo").text(moment.utc(event.endForEdit).locale(language).format('l LT'));
            }
            $("#ActionsWho").text(event.fullName);
            if (event.canEdit) {
                $("#dialog-select-action button").show();
            }
            else {
                $("#dialog-select-action button").hide();
            }
            $("#dialog-select-action").dialog("open");
        }
        else {
            if (event.allDay) {
                $("#ActionsFromEventClassic").text(moment.utc(event.start).locale(language).format('l'));
                $("#ActionsToEventClassic").text(moment.utc(event.endForEdit).locale(language).format('l'));
            }
            else {
                $("#ActionsFromEventClassic").text(moment.utc(event.start).locale(language).format('l LT'));
                $("#ActionsToEventClassic").text(moment.utc(event.endForEdit).locale(language).format('l LT'));
            }
            $("#ActionsWhoEventClassic").text(event.fullName);
            $("#ActionsNameEventClassic").text(event.title);
            if (event.canEdit) {
                $("#dialog-select-event-classic-action button").show();
            }
            else {
                $("#dialog-select-event-classic-action button").hide();
            }
            $("#dialog-select-event-classic-action").dialog("open");
        }
    }
    else {
        //jen pro nedostupnost
        getData(evId);
    }
}

function setCrowd(id, fullName, start, end, representationUserProviderKey, representationType, typeUnavailability, allDay) {
    $("#crowdId").val(id);
    $("#CrowdOperator").val(representationUserProviderKey).trigger("change");
    $("input:radio[name='RepresentationType'][value='" + representationType + "']").prop('checked', true);
    var value = $('input[name="RepresentationType"]:checked').val();
    if (value == 2) {
        $("#CrowdOperator").select2("enable", true);
    }
    else {
        $("#CrowdOperator").select2("enable", false);
    }
    $("#dialog-set-crowd").dialog("open");
}

function addZero(i) {
    if (i < 10) {
        i = "0" + i;
    }
    return i;
}

function editUnavailability(id, description, userProviderKey, userUnavailabilityTypeId, allDay, start, end, calendarId, sendReminderForEveryone, reminders) {
    clearDialog();

    $("#unavailabilityId").val(id);
    $("#EventFromDate").val(moment.utc(start).locale(language).format('l'));
    $("#EventToDate").val(moment.utc(end).locale(language).format('l'));
    $("#EventFromTime").val(moment.utc(start).locale(language).format('HH:mm'));
    $("#EventToTime").val(moment.utc(end).locale(language).format('HH:mm'));
    $("#EventDescription").val(description);
    $("#Operator").val(userProviderKey).trigger("change");
    $("#Type").val(userUnavailabilityTypeId).trigger("change");
    $("#AllDay").prop("checked", allDay);
    $("#RemindeEverybody").prop("checked", sendReminderForEveryone);
    $("#divReminders .text-with-hiding-buttons").remove();
    $.each(reminders, function (index, value) {
        var html = $("#ReminderTemplate").html();
        $('#divReminders').append(html);
        $('#divReminders').find(".text-with-hiding-buttons:last .reminder-type").data("id", value.Id);
        $('#divReminders').find(".text-with-hiding-buttons:last .reminder-type").val(value.Type);
        $('#divReminders').find(".text-with-hiding-buttons:last .reminder-time").val(value.Time);
    });
    $("#EventCalendars").val(calendarId).trigger("change");

    checkAllDay();
    $('#CreateNewUnavaibleSaveButton').button('option', 'label', Localization_Save);
    $('#dialog-create-new-unavaible').dialog('option', 'title', Localization_CalendarScheduler_EditUnavailability);
    $("#dialog-create-new-unavaible").dialog("open");

}

function convertNumber(time) {
    var tm = time.split(":");
    time = parseInt(tm[0]) * 60;
    time += parseInt(tm[1]);
    return time;
}

function deleteEvent(id, type) {
    $.ajax({
        url: RQ_URL + '/CalendarScheduler/DeleteEvent',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            id: id,
            type: type
        }),
        success: function (g) {
            reloadData();
        },
        error: function (error) {
            alert(error.responseText);
        },
    });
}

function addNewEventClassic() {
    clearEventClassicDialog();
    $('#CreateNewEventSaveButton').button('option', 'label', Localization_Create);
    $("#EventClassicCalendars").trigger("change");
    $("#dialog-create-new-event").dialog("option", 'title', Localization_CalendarScheduler_NewEvent);
    $("#dialog-create-new-event").dialog("open");
}

function addNewUnavaible() {
    clearDialog();
    $('#CreateNewUnavaibleSaveButton').button('option', 'label', Localization_Create);
    $("#EventCalendars").trigger("change");
    $('#dialog-create-new-unavaible').dialog('option', 'title', Localization_CalendarScheduler_NewUnavailability);
    $("#dialog-create-new-unavaible").dialog("open");
}

function changeDate(id, start, end, allDay) {
    $.ajax({
        url: RQ_URL + '/CalendarScheduler/ChangeDate',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            id: id,
            start: start,
            end: end,
            allDay: allDay
        }),
        success: function (g) {
            reloadData();
        },
        error: function (error) {
            alert(error.responseText);
        },
    });
}

function editEventClassic(id, description, allDay, start, end, location, color, title, calendarId, sendReminderForEveryone, reminders, type, ticketIds, tickets) {
    clearEventClassicDialog();

    $("#eventClassicId").val(id);
    $("#EventClassicFromDate").val(moment.utc(start).locale(language).format('l'));
    $("#EventClassicToDate").val(moment.utc(end).locale(language).format('l'));
    $("#EventClassicFromTime").val(moment.utc(start).locale(language).format('HH:mm'));
    $("#EventClassicToTime").val(moment.utc(end).locale(language).format('HH:mm'));
    $("#EventClassicDescription").val(description);
    $("#EventClassicAllDay").prop("checked", allDay);
    $("#EventClassicType").val(type).trigger("change");
    $("#EventClassicLocation").val(location);
    $("#EventClassicName").val(title);
    $("#EventClassicTickets").empty();
    $.each(tickets, function (index, value) {
        $("#EventClassicTickets").append("<option value='" + value.id + "' data-ticketref='" + value.ticketref + "' data-subject='" + value.subject + "'></option>");
    });
    $("#EventClassicTickets").val(ticketIds).trigger("change");
    $("#RemindeEverybodyEventClassic").prop("checked", sendReminderForEveryone);
    $("#divRemindersEventClassic .text-with-hiding-buttons").remove();

    $.each(reminders, function (index, value) {
        var html = $("#ReminderTemplate").html();

        $('#divRemindersEventClassic').append(html);
        $('#divRemindersEventClassic').find(".text-with-hiding-buttons:last .reminder-type").data("id", value.Id);
        $('#divRemindersEventClassic').find(".text-with-hiding-buttons:last .reminder-type").val(value.Type);
        $('#divRemindersEventClassic').find(".text-with-hiding-buttons:last .reminder-time").val(value.Time);
    });
    $("#EventClassicCalendars").val(calendarId).trigger("change");

    checkEventClassicAllDay();
    $('#CreateNewEventSaveButton').button('option', 'label', Localization_Save);
    $("#dialog-create-new-event").dialog("option", 'title', Localization_CalendarScheduler_EditEvent);
    $("#dialog-create-new-event").dialog("open");
}

function clearEventClassicDialog() {
    $(".error").hide();
    $(".shared-calendar").hide();
    $("#eventClassicId").val("");
    if (startDateFromCalendar != null && endDateFromCalendar != null) {
        $("#EventClassicFromDate").datepicker("setDate", new Date(startDateFromCalendar));
        $("#EventClassicToDate").datepicker("setDate", new Date(endDateFromCalendar));
    } else {
        $("#EventClassicFromDate").datepicker("setDate", Date.now());
        $("#EventClassicToDate").datepicker("setDate", Date.now());
    }
    $("#EventClassicLocation").val("");
    $("#EventClassicName").val("");
    $("#EventClassicDescription").val("");
    $("#EventClassicTickets").val(null).trigger("change");
    $("#EventClassicType").val("-1").trigger("change");
    $("#EventClassicAllDay").prop("checked", true);
    $("#RemindeEverybodyEventClassic").prop("checked", false);
    $("#divRemindersEventClassic .text-with-hiding-buttons").remove();
    var html = $("#ReminderTemplate").html();

    $('#divRemindersEventClassic').append(html);

    checkEventClassicAllDay();
}

function clearDialog() {
    $(".error").hide();
    $(".shared-calendar").hide();
    $("#EventType-error").hide();
    $("#unavailabilityId").val("0");
    if (startDateFromCalendar != null && endDateFromCalendar != null) {
        $("#EventFromDate").datepicker("setDate", new Date(startDateFromCalendar));
        $("#EventToDate").datepicker("setDate", new Date(endDateFromCalendar));
    } else {
        $("#EventFromDate").datepicker("setDate", Date.now());
        $("#EventToDate").datepicker("setDate", Date.now());
    }
    $("#EventFromTime").val("");
    $("#EventToTime").val("");
    $("#EventDescription").val("");
    $("#Operator").val(myKey).trigger("change");
    $("#Type").val("-1").trigger("change");
    $("#AllDay").prop("checked", true);
    $("#RemindeEverybody").prop("checked", false);
    $("#divReminders .text-with-hiding-buttons").remove();
    var html = $("#ReminderTemplate").html();
    $('#divReminders').append(html);

    checkAllDay();
}

function reloadCalendarSchedulers() {
    $("#EventClassicCalendarsDiv").html("<div class='loading-32'></div>");
    $("#EventClassicCalendarsDiv").load(RQ_URL + "/CalendarScheduler/CalendarSchedulerDropDownPartial/EventClassicCalendars");
    $("#EventCalendarsDiv").html("<div class='loading-32'></div>");
    $("#EventCalendarsDiv").load(RQ_URL + "/CalendarScheduler/CalendarSchedulerDropDownPartial/EventCalendars");
    $("#dialog-calendar-scheduler-manage").html("<div class='loading-32'></div>");
    $("#dialog-calendar-scheduler-manage").load(RQ_URL + "/CalendarScheduler/AllCalendarSchedulersTable");
    $("#AllCalendarSchedulers").html("<div class='loading-32'></div>");
    $("#AllCalendarSchedulers").load(RQ_URL + "/CalendarScheduler/AllCalendarSchedulers", function () {
        reloadData();
    });
}

$.fn.initColorpicker = function () {
    $(this).colorpicker({
        colorSelectors: {
            'stickynote': '#ffffcc',
            'orange': '#f0ad4e',
            'green': '#5cb85c',
            'lightblue': '#5bc0de',
            'darkblue': '#337ab7',
            'lightred': '#d9534f',
            'darkred': '#b90600',
            'pink': '#ec2b8c',
            'purple': '#763f98',
            'default': '#7f7f7f',
            'chocolate': '#7B3F00',
        }
    })
    .on('changeColor', function (event) {
        $(this).find("input[type='text']").val(event.color.toHex());
    })
    .on('hidePicker', function (event) {
        $(this).find("input[type='text']").val(event.color.toHex());
    });
}