﻿$(document).ready(function () {
    $("#ticketViewDiv").on("click", "#TicketStickyNotes .remove-ticket-sticky-note", function (event) {
        event.stopPropagation(); //to prevent $('html').click
        selectedId = $(this).closest(".ticket-sticky-note").data("id");
        $selectedDeleteStickyNote = $(this).closest(".ticket-sticky-note");
        $("#dialog-delete-sticky-note").dialog("open");
    });

    $("#ticketViewDiv").on("click", "#TicketStickyNotes .edit-ticket-sticky-note", function (event) {
        event.stopPropagation(); //to prevent $('html').click
    });

    $("#ticketViewDiv").on("click", "#TicketStickyNotes .btn-ticket-sticky-note-cancel", function (event) {
        event.stopPropagation(); //to prevent $('html').click
        cancelTicketStickyNote($(this).closest(".ticket-sticky-note"));
    });

    $("#ticketViewDiv").on("click", "#TicketStickyNotes .btn-ticket-sticky-note-save", function (event) {
        event.stopPropagation(); //to prevent $('html').click
        saveTicketStickyNote($(this).closest(".ticket-sticky-note"));
    });

    $("#ticketViewDiv").on("click", "#TicketStickyNotes .ticket-sticky-note-text.ticket-sticky-note-can-edit", function (event) {
        event.stopPropagation(); //to prevent $('html').click
        editTicketStickyNote($(this).closest(".ticket-sticky-note"));
    });

    $("#ticketViewDiv").on("click", "#TicketStickyNotes .is-for-operators", function (event) {
        event.stopPropagation(); //to prevent $('html').click
        changeValueInCookie(false);
    });

    $("#ticketViewDiv").on("click", "#TicketStickyNotes .is-private", function (event) {
        event.stopPropagation(); //to prevent $('html').click
        changeValueInCookie(true);
    });
});

function changeValueInCookie(value) {
    var cookie = $.deparam($.cookie("TicketViewStickyNotes-" + loggedUserProviderKey));
    cookie.NotePrivate = value;
    var o = $.param(cookie);
    $.cookie("TicketViewStickyNotes-" + loggedUserProviderKey, o, { expires: 365 }); //expiration in days
}

function AddNewStickyNote() {
    var $ticketStickyNotes = $("#TicketStickyNotes");

    var divLoading = document.createElement('div');
    $(divLoading).addClass('ticket-sticky-note loading-32');
    $ticketStickyNotes.prepend(divLoading);

    $.ajax({
        url: RQ_URL + '/Tickets/NewTicketStickyNote',
        type: "POST",
        contentType: "application/json; charset=utf-8", //send
        dataType: "html", //receive
        data: JSON.stringify({
        }),
        success: function (html) {                                                                                                                                                                                            
            $(divLoading).remove();
            $ticketStickyNotes.prepend(html);
            $ticketStickyNotes.find('.change-color').initColorpicker(); //reinit
            initBsTooltip();

            var $ticketStickyNote = $ticketStickyNotes.find('.ticket-sticky-note:first');
            editTicketStickyNote($ticketStickyNote);
            $ticketStickyNote.find("textarea").height(70);

            var cookie = $.deparam($.cookie("TicketViewStickyNotes-" + loggedUserProviderKey));

            if (cookie.NotePrivate != null) {
                $ticketStickyNote.find(cookie.NotePrivate == "true" ? ".is-private" : ".is-for-operators").prop('checked', true);
            }
        },
    })
    .fail(function (error) {
        if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
    });
}

    function editTicketStickyNote($ticketStickyNote) {
        var $ticketStickyNoteText = $ticketStickyNote.find(".ticket-sticky-note-text");
        var $ticketStickyNoteInformation = $ticketStickyNote.find(".ticket-sticky-note-information");
        var $ticketStickyNoteEdit = $ticketStickyNote.find(".ticket-sticky-note-edit");

        $ticketStickyNote.find(".ticket-sticky-note-information a.user-info").popover('hide');

        var height = $ticketStickyNoteText.height();

        if ($ticketStickyNote.find(".ticket-sticky-note-radio-value").val() == "true") {
            $ticketStickyNote.find(".is-private").prop('checked', true);
        }
        else {
            $ticketStickyNote.find(".is-for-operators").prop('checked', true);
        }

        $ticketStickyNoteInformation.hide();
        $ticketStickyNoteText.hide();
        $ticketStickyNoteEdit.show();

        $ticketStickyNote.find("textarea").height(height);
        $ticketStickyNote.find("textarea").focus();
    }

    function cancelTicketStickyNote($cancelTicketStickyNote) {
        if ($cancelTicketStickyNote.data("id")) {
            $cancelTicketStickyNote.find("textarea").val($.trim($cancelTicketStickyNote.find(".ticket-sticky-note-text").text()));
            $cancelTicketStickyNote.find(".ticket-sticky-note-text").show();
            $cancelTicketStickyNote.find(".ticket-sticky-note-information").show();
            $cancelTicketStickyNote.find(".ticket-sticky-note-edit").hide();
        }
        else {
            $cancelTicketStickyNote.remove();
        }
    }

    function saveTicketStickyNote($saveTicketStickyNote) {
        $saveTicketStickyNote.find(".ticket-sticky-note-text").text($.trim($saveTicketStickyNote.find("textarea").val()));
        $saveTicketStickyNote.find(".ticket-sticky-note-text").show();
        $saveTicketStickyNote.find(".ticket-sticky-note-information").show();
        $saveTicketStickyNote.find(".ticket-sticky-note-edit").hide();
        $.ajax({
            url: RQ_URL + '/Tickets/SaveTicketStickyNote',
            type: "POST",
            contentType: "application/json; charset=utf-8", //send
            dataType: "html", //receive
            data: JSON.stringify({
                id: $saveTicketStickyNote.data("id"),
                ticketId: ticketId,
                text: $.trim($saveTicketStickyNote.find("textarea").val()),
                color: $saveTicketStickyNote.find(".change-color").data('colorpicker').color.toHex(),
                isPrivate: $saveTicketStickyNote.find(".is-private").is(":checked"),
                signalRConnectionId: $.connection.hub.id,
            }),
            success: function (data) {
                if (data == null) {
                    $saveTicketStickyNote.closest(".ticket-sticky-note").remove();
                }
                else {
                    $saveTicketStickyNote.closest(".ticket-sticky-note").replaceWith(data);
                    $(".ticket-sticky-note").find('.change-color').initColorpicker(); //reinit
                    initBsTooltip();
                }
            },
        })
        .fail(function (error) {
            if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
        });
    }

    function deleteTicketStickyNote(selectedId, $deleteTicketStickyNote) {
        if (selectedId == undefined) {
            $deleteTicketStickyNote.remove();
            $("#dialog-delete-sticky-note").dialog("close");
        }
        else {
            $.ajax({
                url: RQ_URL + '/Tickets/DeleteTicketStickyNote',
                type: "POST",
                contentType: "application/json; charset=utf-8", //send
                dataType: "json", //receive
                data: JSON.stringify({
                    id: selectedId,
                    signalRConnectionId: $.connection.hub.id,
                }),
                success: function (data) {
                    $deleteTicketStickyNote.hide('medium', function () {
                        $(this).remove();
                    });

                    $("#dialog-delete-sticky-note").dialog("close");
                },
            })
            .fail(function (error) {
                if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
            });
        }
    }

    var closingColorPicker = false;

    $.fn.initColorpicker = function () {
        $(this).colorpicker({
            colorSelectors: {
                'stickynote': '#ffffcc',
                'orange': '#f0ad4e',
                'green': '#5cb85c',
                'lightblue': '#5bc0de',
                'darkblue': '#337ab7',
                'lightred': '#d9534f',
                'darkred': '#b90600',
                'pink': '#ec2b8c',
                'purple': '#763f98',
                'default': '#7f7f7f',
                'chocolate': '#7B3F00',
            }
        })
        .on('changeColor', function (event) {
            var color = event.color;
            color.a = '0.9';
            $(this).closest(".ticket-sticky-note").css('background-color', color.toHex());
        })
        .on('hidePicker', function (event) {
            if (!closingColorPicker) { //hack to prevent calling this twice, maybe colorpicker bug

                closingColorPicker = true;
                $stickyNote = $(this).closest(".ticket-sticky-note");

                $.ajax({
                    url: RQ_URL + '/Tickets/GetTicketStickyNoteColors',
                    type: "POST",
                    contentType: "application/json; charset=utf-8", //send
                    dataType: "json", //receive
                    data: JSON.stringify({
                        id: $stickyNote.data("id"),
                        color: event.color.toHex(),
                    }),
                    success: function (data) {
                        var color = event.color;
                        color.a = '0.9';
                        $stickyNote.closest(".ticket-sticky-note").css('background-color', color.toHex());
                        $stickyNote.css("color", data.textColor);
                        $stickyNote.find("textarea").css("color", data.textColor);
                        $stickyNote.find("textarea").css("border-color", data.borderColor);
                        $stickyNote.find(".ticket-sticky-note-actions").removeClass(".ticket-sticky-note-actions-hover")
                        $stickyNote.find(".ticket-sticky-note-actions a").css("color", data.borderColor);
                        $stickyNote.find(".ticket-sticky-note-information").css("color", data.footerColor);
                        $stickyNote.find(".ticket-sticky-note-information a").css("color", data.footerActionColor);
                        $stickyNote.find(".ticket-sticky-note-actions a").mouseover(function () {
                            $(this).css("color", data.textColor);
                    }).mouseout(function () {
                            $(this).css("color", data.borderColor);
                        });
                        closingColorPicker = false;
                    },
                })
                .fail(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
            }
        });
    }